
// Autoumschalten, bei keinem VESA
// DAC switchable 6bit->8bit wenn mglich
// Alte VESA Modi (andere Nummern) einfgen

#include <graph.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <time.h>
#include <malloc.h>
#include <mem.h>
#include <sys\types.h>
#include <stddef.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <i86.h>
#include <math.h>

#define BOOL                int
#define UBYTE               unsigned char
#define UWORD               unsigned short
#define ULONG               unsigned long

#define TRUE                (!0)
#define FALSE               0

#define M0                  Sy_MouseShow(0);
#define M1                  Sy_MouseShow(!0);

#define _320x200c256        0x013           // Standard VGA
#define _640x480c256        0x101           // VESA SVGA
#define _640x480c32k        0x110           // VESA SVGA
#define _640x480c64k        0x111           // VESA SVGA
#define _640x480c16m        0x112           // VESA SVGA
#define _800x600c256        0x103           // VESA SVGA
#define _1024x768c256       0x105           // VESA SVGA
#define _1280x1024c256      0x107           // VESA SVGA

#define MAX_SCRY            1280            // Max Bildschirmzeilenzahl fr Tex-map
#define MAXXPARTS           64              // 10x10 Pixel max.
#define MAXYPARTS           48
#define MAXLIN              15              // 10 Linien+Rand
#define MAXSTATES           11              // Anzahl der Zustnde(Quelle&Soft eingerechnet)
#define MAXDIS              150

/****************************************************************************/

static struct rminfo
{
    long EDI;
    long ESI;
    long EBP;
    long reserved_by_system;
    long EBX;
    long EDX;
    long ECX;
    long EAX;
    short flags;
    short ES,DS,FS,GS,IP,CS,SP,SS;
} RMI;

typedef struct
{
    char manufacturer;
    char version;
    char encoding;
    char bitsperpixel;
    UWORD xmin;
    UWORD ymin;
    UWORD xmax;
    UWORD ymax;
    UWORD hres;
    UWORD vres;
    char colormap[48];
    char reserved;
    char nplanes;
    UWORD bytesperline;
    UWORD palettetype;
    char filler[58];
} PCXHEADER;

struct VESA_infoblockS
{
    char  vesa[4];          // 00 'VESA'
    short version;          // 04 VESA Versionscode
    void  far *card_data;   // 06 Adresse der Kartenspez. Daten
    long  reserviert;       // 10 reserviert
    long  modetab;          // 14 Adresse der Modustabelle
    short pageanz;          // 18 Anzahl der vorhandenen 64K Blcke
                            //    (ergibt Speichergre der Grafikkarte)
    char  block[256];       // von Offset 20 - 127 sind weitere
                            // hersteller-spezifische Mode-Nummern abgelegt
};


struct MemPic
{
    int b,h;
    char *ptr;
};


struct VESA_modeinfoS
{
    UWORD modeattrib;             // 00 Modusattribute
    UBYTE attrib_fa;              // 02 Attribute Fenster A
    UBYTE attrib_fb;              // 03 Attribute Fenster B
    UWORD window_align;           // 04 Kleinstmgliches Adreoffset, das eingeblendet
                                  //    werden kann, z.B. 8 -> 0K, 8K, 16K usw.
    UWORD window_size;            // 06 Wieviel eines Fensters wird eingeblendet (z.B. 64K)
    UWORD segm_wa;                // 08 Segmentadresse von Fenster A
    UWORD segm_wb;                // 10 Segmentadresse von Fenster B
    void *direct_call;        // 12 Direkt-Aufruf (intr 10 kann umgangen werden)
    UWORD bpz;                    // 16 Bytes pro Zeile
    UWORD xres;                   // 18 Horizontale Auflsung
    UWORD yres;                   // 20 Vertikale Auflsung
    UBYTE charxsize;              // 22 Breite eines Zeichenzelle
    UBYTE charysize;              // 23 Hhe einer Zeichenzelle
    UBYTE bitplanes;              // 24 Anzahl der Bildebenen
    UBYTE bpp;                    // 25 Anzahl der Bits pro Pixel
    UBYTE blocks;                 // 26 Anzahl der Speicherblcke
    UBYTE mem_info;               // 27 Speicherorganisation
    UBYTE bank_size;              // 28 Gre der Speicherbank in KB
    UBYTE bank_anz;               // 29 Anzahl der verfgbaren Bildseiten
    UBYTE reserviert1;            // 30
    UBYTE red_masksize;           // 31 Maskengre  Rotanzeil
    UBYTE red_pos;                // 32 Feldposition Rotanzeil
    UBYTE green_masksize;         // 33 Maskengre  Grnanteil
    UBYTE green_pos;              // 34 Feldposition Grnanteil
    UBYTE blue_masksize;          // 35 Maskengre  Blauanteil
    UBYTE blue_pos;               // 36 Feldposition Blauanteil
    UBYTE res_masksize;           // 37 Reservierte  Maskengre
    UBYTE res_pos;                // 38 Reservierte  Feldposition
    UBYTE truecolor_info;         // 39 Information True_Color
    UBYTE reserviert2;            // 40
    UBYTE rest[256];              // insgesamt 256 Bytes VESA_modeinfo
};


struct Clip
{
    short xa,ya,xe,ye;
};


/****************************************************************************/



struct relS
{
    float x,y;          // Vektor
};

struct relWS
{
    float x,y,w;  // Vektor mit Wichtung
    int state;
};

struct PunS
{
    struct relWS b[MAXLIN];
    float newx,newy;
};

struct LinS
{
    struct relS p,v;  // Punkt, orthonormaler Vektor
};

struct LinTabS
{
    float x,u,v;
};



// ***************************************************************************

// Vesa
    UBYTE           *gfx_pic,*gfx_pic2;
    long            gfx_bpl;
    UWORD           VESA_AktPageMem=-1,VESA_AktPage2Mem=-1;
    UWORD           *VESA_AktPage=&VESA_AktPageMem,*VESA_AktPage2=&VESA_AktPage2Mem;
  struct VESA_modeinfoS far *VESA_modeinfo=0;
 struct VESA_infoblockS far *VESA_infoblock=0;
    ULONG           VESA_WinMask;
    ULONG           VESA_WinShift;
    BOOL            VESA_VideoOn=FALSE;
    BOOL            VESA_TrueCol=FALSE;
    short           VESA_Bpp,VESA_Bypp;           // Bits & Bytes pro Pixel
    UBYTE           *VESA_SoftScreen=0;
    int             VESA_SoftWidth,WinWNr,WinRNr;

// Tabellen, Puffer
    UBYTE far       *RGBtab;            // konventioneller Speicher
    ULONG           MouseBack[128];     // Hintergrund des Mauspfeiles
    UBYTE           *FontTab=0;         // Tabelle mit 8x8 Font

// Grafik
    short               MyGfxX=-1,MyGfxY=-1;
    int                 ScreenModeNum=1,ScrX,ScrY,
                        DarkestColor=0x0,LightestColor=0xFFFFFF,
                        RedestColor=0xFF0000,GreyestColor=0x989898,
                        ShadowColor=0x303030,MyAktColor=0;
    struct Clip         ScrClip;
    BOOL                SoftMode=FALSE;

// Mouse
    int                 MouseTri=-1,MouseX=-1,MouseY=-1,MoveTri=-1,MouseState=0;
    BOOL                MouseShow=FALSE,ButtonPress=FALSE;

// Intern
    PCXHEADER           pcxhdr;
    struct MemPic       Pic[2];		// 0: 8 Bit Original, 1:32Bit Original
    int                 mx,my,AktMenu=0,ExitCode=0,bxa,bxe,bya,bye;
    long                zap=0;
    BOOL                RunPrg=TRUE,LineOn=FALSE;
    time_t              MyV_Timer;
    UBYTE far           *DosMem;
    UWORD               DosSeg;

// Morph
    int                 PriList[MAXXPARTS*MAXYPARTS];
    struct LinTabS      LineTable[MAX_SCRY][2];
    struct PunS         p[(MAXXPARTS+1)*(MAXYPARTS+1)];
    struct LinS         l[MAXSTATES][MAXLIN+1];  // 16 Zustnde, MAXLIN Linien
    int                 XParts=32,YParts=24,Lin=0;
    int                 AktLin=0;          // 0:keine,neg:PunktA,pos:PunktB
    int                 AktState=0;        // 0:Quelle,1-.. Zielzustnde
    BOOL                FineGfx=FALSE,InverseGfx=FALSE;
    BOOL                DoShowLines=TRUE;
    int                 PicXA,PicYA,PicXE,PicYE;
	BOOL				UsedState[MAXSTATES];

/****************************************************************************/

// Vesa
    long    ttt=0;
    BOOL    SetVESA                 ( UWORD );
    void    PutPixel                ( UWORD, UWORD, ULONG );
    void    PutPixel15              ( UWORD, UWORD, UWORD );
    void    PutPixelRGB             ( UWORD, UWORD, UBYTE, UBYTE, UBYTE );
    ULONG   GetPixel                ( UWORD, UWORD );
    void    PutPixelDown            ( UWORD, UWORD, UWORD, ULONG );
    void    PutPixelRight           ( UWORD, UWORD, UWORD, ULONG );
    void    CopySoftScreen          ( struct Clip * );
    void    outtextxy               ( UWORD, UWORD, char * );
    void    setcolor                ( int );

// PCX,Pic
    BOOL    readpcx                 ( char *, struct MemPic * );
    BOOL    writepcx                ( char *, struct MemPic * );
    void    SetRGBPaletteTAB        ( void );

// System
    void    video                   ( void );
    void    CheckGfxErrors          ( void );
    void    CloseAll                ( void );

// Mouse
    void    Sy_MouseInstall         ( void );
    void    Sy_MouseShow            ( BOOL );
    void    Sy_MouseGet             ( int *, int *, int * );
    void    Sy_MouseArea            ( int, int, int, int );
    void    Sy_MouseFree            ( void );


// Intern

// Morph
    void    InitGrid                ( int, int );
    void    RecalcGrid              ( void );
    void    RenderGrid              ( struct MemPic * );
    void    WriteToLineTable        ( float, float, float, float, float, float, float, float );  
    void    ShowLines               ( void );

/****************************************************************************/


BOOL SetVesa( UWORD gfx_mode )
{
    union  REGS regs;
    struct SREGS sregs;

    memset(&sregs,0,sizeof(sregs));
    if(gfx_mode==_320x200c256)
    {
        regs.w.ax=0x13;
        int386(0x10,&regs,&regs);

        gfx_pic=(UBYTE *)0xA0000;gfx_pic2=gfx_pic;
        gfx_bpl=320;VESA_WinMask=0xFFFF;
        VESA_AktPage=0;VESA_WinShift=16;
        VESA_VideoOn=TRUE;
        WinWNr=0;WinRNr=0;VESA_Bpp=8;
        VESA_AktPage2=&VESA_AktPageMem;
        VESA_AktPageMem=0;VESA_AktPage2Mem=0;
        return(TRUE);
    }


    memset(&RMI,0,sizeof(RMI));            // Vesa Info
    RMI.EAX=0x00004F00;
    RMI.EDI=0;
    RMI.ES=DosSeg;
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RMI);
    regs.x.edi=FP_OFF(&RMI);
    int386x(0x31,&regs,&regs,&sregs);
    if((RMI.EAX & 0xFFFF)!=0x004F)return(FALSE);
    if(DosMem[0]!='V' || DosMem[1]!='E' || DosMem[2]!='S' || DosMem[3]!='A')
        return(FALSE);

    memset(&RMI,0,sizeof(RMI));                   // Extended Info to Mode
    RMI.EAX=0x00004F01;
    RMI.EDI=0;
    RMI.ES=DosSeg;
    RMI.ECX=gfx_mode;
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RMI);
    regs.x.edi=FP_OFF(&RMI);
    int386x(0x31,&regs,&regs,&sregs);
    if((RMI.EAX & 0xFFFF)!=0x004F)return(FALSE);

    memset(&RMI,0,sizeof(RMI));                   // Set Mode
    RMI.EAX=0x00004F02;
    RMI.EBX=gfx_mode;
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RMI);
    regs.x.edi=FP_OFF(&RMI);
    int386x(0x31,&regs,&regs,&sregs);
    if((RMI.EAX & 0xFFFF)!=0x004F)return(FALSE);
    VESA_VideoOn=TRUE;

    memset(&RMI,0,sizeof(RMI));                   // Get logical scan line
    RMI.EAX=0x00004F06;
    RMI.EBX=1;
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RMI);
    regs.x.edi=FP_OFF(&RMI);
    int386x(0x31,&regs,&regs,&sregs);
    if((RMI.EAX & 0xFFFF)!=0x004F)return(FALSE);
    gfx_bpl=RMI.EBX;

    if(!((VESA_modeinfo->attrib_fb) & 0x01))   // gibt es 2 Fenster?
    {                         // > ein Fenster
        gfx_pic=(UBYTE *)(16*(long)VESA_modeinfo->segm_wa);
        gfx_pic2=gfx_pic;
        WinWNr=0;WinRNr=0;
        VESA_AktPage2=&VESA_AktPageMem;
    }
    else
    {                         // > zwei Fenster
        if((VESA_modeinfo->attrib_fb) & 0x02)      // FensterB lesbar
        {
            WinRNr=1;WinWNr=0;
            gfx_pic=(UBYTE *)(16*(long)VESA_modeinfo->segm_wa);
            gfx_pic2=(UBYTE *)(16*(long)VESA_modeinfo->segm_wb);
        }
        else
        {
            WinWNr=1;WinRNr=0;
            VESA_AktPage=&VESA_AktPage2Mem;
            VESA_AktPage2=&VESA_AktPageMem;
            gfx_pic=(UBYTE *)(16*(long)VESA_modeinfo->segm_wb);
            gfx_pic2=(UBYTE *)(16*(long)VESA_modeinfo->segm_wa);
        }
    }

    VESA_Bpp=VESA_modeinfo->bpp;

    switch(VESA_modeinfo->window_align)
    {
        case 1:   VESA_WinShift=10; break;
        case 2:   VESA_WinShift=11; break;
        case 4:   VESA_WinShift=12; break;
        case 8:   VESA_WinShift=13; break;
        case 16:  VESA_WinShift=14; break;
        case 32:  VESA_WinShift=15; break;
        case 64:  VESA_WinShift=16; break;
        case 128: VESA_WinShift=17; break;
        case 256: VESA_WinShift=18; break;
        default: return(FALSE);
    }
    VESA_WinMask=(1<<VESA_WinShift)-1;
    return(TRUE);
}




void putpixel( UWORD x, UWORD y, ULONG col )
{
    if(x<=ScrX && y<=ScrY)
    {
        union REGS regs;
        long pic;
        UWORD r;

        switch(VESA_Bpp)
        {
            case 32:
            {
                pic=(x<<2)+(long)y*gfx_bpl;
                r=pic>>VESA_WinShift;
                if(r!=*VESA_AktPage)
                {
                    regs.w.ax=0x4F05;
                    regs.w.bx=WinWNr;
                    regs.w.dx=r;                                // Page
                    int386(0x10,&regs,&regs);
                    *VESA_AktPage=r;
                }
                *((ULONG *)(gfx_pic+(pic & VESA_WinMask)))=col;
            }
            break;

            case 24:
            {
                UBYTE *M;

                pic=(x<<1)+x+(long)y*gfx_bpl;
                r=pic>>VESA_WinShift;
                if(r!=*VESA_AktPage)
                {
                    regs.w.ax=0x4F05;
                    regs.w.bx=WinWNr;
                    regs.w.dx=r;                             // Page
                    int386(0x10,&regs,&regs);
                    *VESA_AktPage=r;
                }
                M=gfx_pic+(pic & VESA_WinMask);
                *M++=col;*M++=col>>8;*M=col>>16;
            }
            break;

            case 15:
            {
                UWORD *M;

                pic=(x<<1)+(long)y*gfx_bpl;
                r=pic>>VESA_WinShift;
                if(r!=*VESA_AktPage)
                {
                    regs.w.ax=0x4F05;
                    regs.w.bx=WinWNr;
                    regs.w.dx=r;                             // Page
                    int386(0x10,&regs,&regs);
                    *VESA_AktPage=r;
                }
                M=(UWORD *)(gfx_pic+(pic & VESA_WinMask));
                *M=((col>>19)<<10)+(((col>>11)&0x1F)<<5)+((col>>3)&0x1F);
            }
            break;

            case 8:
            {
                pic=x+(long)y*gfx_bpl;
                r=pic>>VESA_WinShift;
                if(r!=*VESA_AktPage)
                {
                    regs.w.ax=0x4F05;
                    regs.w.bx=WinWNr;
                    regs.w.dx=r;                                // Page
                    int386(0x10,&regs,&regs);
                    *VESA_AktPage=r;
                }
                *((UBYTE *)(gfx_pic+(pic & VESA_WinMask)))=col;
            }
            break;
        }
    }
}



void PutPixel15( UWORD x, UWORD y, UWORD col )
{
    long pic;
    UWORD r;
    UWORD *M;

    pic=(x<<1)+(long)y*gfx_bpl;
    r=pic>>VESA_WinShift;
    if(r!=*VESA_AktPage)
    {
        union REGS regs;

        regs.w.ax=0x4F05;
        regs.w.bx=WinWNr;
        regs.w.dx=r;                             // Page
        int386(0x10,&regs,&regs);
        *VESA_AktPage=r;
    }
    M=(UWORD *)(gfx_pic+(pic & VESA_WinMask));
    *M=col;
}


ULONG GetPixel( UWORD x, UWORD y )
{
    union REGS regs;
    long pic;
    UWORD r;
    ULONG col;

    if(x<=ScrX && y<=ScrY)
    {
        switch(VESA_Bpp)
        {
            case 32:
            {
                pic=(x<<2)+(long)y*gfx_bpl;r=pic>>VESA_WinShift;

                if(r!=*VESA_AktPage2)
                {
                    regs.w.ax=0x4F05;
                    regs.w.bx=WinRNr;
                    regs.w.dx=r;                                // Page
                    int386(0x10,&regs,&regs);
                    *VESA_AktPage2=r;
                }
                return(*((ULONG *)(gfx_pic2+(pic & VESA_WinMask))));
            }
            break;

            case 24:
            {
                UBYTE *M;

                pic=(x<<1)+x+(long)y*gfx_bpl;r=pic>>VESA_WinShift;

                if(r!=*VESA_AktPage2)
                {
                    regs.w.ax=0x4F05;
                    regs.w.bx=WinRNr;
                    regs.w.dx=r;                                // Page
                    int386(0x10,&regs,&regs);
                    *VESA_AktPage2=r;
                }
                M=gfx_pic2+(pic & VESA_WinMask);
                col=*M++;col+=(*M++)<<8;col+=(*M)<<16;
                return(col);
            }
            break;

            case 15:
            {
                UWORD *M;

                pic=(x<<1)+(long)y*gfx_bpl;r=pic>>VESA_WinShift;

                if(r!=*VESA_AktPage2)
                {
                    regs.w.ax=0x4F05;
                    regs.w.bx=WinRNr;
                    regs.w.dx=r;                                // Page
                    int386(0x10,&regs,&regs);
                    *VESA_AktPage2=r;
                }
                M=(UWORD *)(gfx_pic2+(pic & VESA_WinMask));
                col=(((*M)&0x7b00)<<9)+(((*M)&0x03E0)<<6)+(((*M)&0x001F)<<3);
                return(col);
            }
            break;

            case 8:
            {
                pic=x+(long)y*gfx_bpl;r=pic>>VESA_WinShift;

                if(r!=*VESA_AktPage2)
                {
                    regs.w.ax=0x4F05;
                    regs.w.bx=WinRNr;
                    regs.w.dx=r;                                // Page
                    int386(0x10,&regs,&regs);
                    *VESA_AktPage2=r;
                }
                return(*((UBYTE *)(gfx_pic2+(pic & VESA_WinMask))));
            }
            break;
        }
    }
    return(0);
}



void PutPixelRight( UWORD x, UWORD y, UWORD h, ULONG col )
{
    union REGS regs;
    long pic;
    UWORD n;

    switch(VESA_Bpp)
    {
        case 32:
        {
            ULONG *M;

            pic=(x<<2)+(long)y*gfx_bpl;
            n=pic>>VESA_WinShift;
            if(n!=*VESA_AktPage)
            {
                regs.w.ax=0x4F05;
                regs.w.bx=WinWNr;
                regs.w.dx=n;                                // Page
                int386(0x10,&regs,&regs);
                *VESA_AktPage=n;
            }
            M=(ULONG *)(gfx_pic+(pic & VESA_WinMask));
            if(n==(pic+(h<<2)-1)>>VESA_WinShift)
            {
                for(n=0;n<h;n++)*M++=col;
            }
            else
            {
                for(n=0;n<h;n++)PutPixel(x++,y,col);
            }
        }
        break;

        case 24:
        {
            UBYTE *M;

            pic=(x<<1)+x+(long)y*gfx_bpl;
            n=pic>>VESA_WinShift;
            if(n!=*VESA_AktPage)
            {
                regs.w.ax=0x4F05;
                regs.w.bx=WinWNr;
                regs.w.dx=n;                                // Page
                int386(0x10,&regs,&regs);
                *VESA_AktPage=n;
            }
            M=gfx_pic+(pic & VESA_WinMask);
            if(n==(pic+h*3-1)>>VESA_WinShift)
            {
                UBYTE r=col>>16,g=col>>8,b=col;

                for(n=0;n<h;n++){ *M++=b;*M++=g;*M++=r; }
            }
            else
            {
                for(n=0;n<h;n++)PutPixel(x++,y,col);
            }
        }
        break;

        case 15:
        {
            UWORD *M;

            pic=(x<<1)+(long)y*gfx_bpl;
            n=pic>>VESA_WinShift;
            if(n!=*VESA_AktPage)
            {
                regs.w.ax=0x4F05;
                regs.w.bx=WinWNr;
                regs.w.dx=n;                                // Page
                int386(0x10,&regs,&regs);
                *VESA_AktPage=n;
            }
            M=(UWORD *)(gfx_pic+(pic & VESA_WinMask));
            if(n==(pic+(h<<1)-1)>>VESA_WinShift)
            {
                UWORD col2=((col>>19)<<10)+(((col>>11)&0x1F)<<5)+((col>>3)&0x1F);

                for(n=0;n<h;n++)*M++=col2;
            }
            else
            {
                for(n=0;n<h;n++)PutPixel(x++,y,col);
            }
        }
        break;

        case 8:
        {
            UBYTE *M;

            pic=x+(long)y*gfx_bpl;
            n=pic>>VESA_WinShift;
            if(n!=*VESA_AktPage)
            {
                regs.w.ax=0x4F05;
                regs.w.bx=WinWNr;
                regs.w.dx=n;                                // Page
                int386(0x10,&regs,&regs);
                *VESA_AktPage=n;
            }
            M=gfx_pic+(pic & VESA_WinMask);
            if(n==(pic+h-1)>>VESA_WinShift)
            {
                for(n=0;n<h;n++)*M++=col;
            }
            else
            {
                for(n=0;n<h;n++)PutPixel(x++,y,col);
            }
        }
    }
}





void outtextxy( UWORD x, UWORD y, char *txt )
{
    ULONG c=MyAktColor;
    short n,xx;
    UBYTE *M,b;

    for(n=0;n<8;n++)
    {
        M=txt;xx=x;
        while(*M!=0)
        {
            if(*M>32)
            {
                b=FontTab[(((*M)-33)<<3)+n];
                if(b&0x80)putpixel(xx,y,c);
                if(b&0x40)putpixel(xx+1,y,c);
                if(b&0x20)putpixel(xx+2,y,c);
                if(b&0x10)putpixel(xx+3,y,c);
                if(b&0x08)putpixel(xx+4,y,c);
                if(b&0x04)putpixel(xx+5,y,c);
                if(b&0x02)putpixel(xx+6,y,c);
                if(b&0x01)putpixel(xx+7,y,c);
            }
            M++;xx+=8;
        }
        y++;
    }
}


void bar( UWORD xa, UWORD ya, UWORD xe, UWORD ye )
{
    for(;ya<(ye+1);ya++)PutPixelRight(xa,ya,xe-xa+1,MyAktColor);
}



void CopySoftscreen( struct Clip *wo )
{
    int y,len=(((wo->xe)-(wo->xa))*VESA_Bypp)+1,xaa=(wo->xa)*VESA_Bypp;
    UBYTE *M,*Q=VESA_SoftScreen+VESA_SoftWidth*(wo->ya)+xaa;
    union REGS regs;
    long pic;
    UWORD n;

    M0;
    pic=xaa+(long)(wo->ya)*gfx_bpl;
    for(y=wo->ya;y<(wo->ye)+1;y++)
    {
        n=pic>>VESA_WinShift;
        if(n!=*VESA_AktPage)
        {
            regs.w.ax=0x4F05;
            regs.w.bx=WinWNr;
            regs.w.dx=n;                                // Page
            int386(0x10,&regs,&regs);
            *VESA_AktPage=n;
        }

        M=gfx_pic+(pic & VESA_WinMask);
        if(n==(pic+len-1)>>VESA_WinShift)
        {
            memcpy(M,Q,len+1);
        }
        else
        {
            switch(VESA_Bpp)
            {
                case 8:
                    {
                        UBYTE *Q2=Q;

                        for(n=wo->xa;n<(wo->xe)+1;n++)PutPixel(n,y,*Q2++);
                    }
                    break;
                case 15:
                    {
                        UWORD *Q2=(UWORD *)Q;

                        for(n=wo->xa;n<(wo->xe)+1;n++)PutPixel15(n,y,*Q2++);
                    }
                    break;
                case 24:
                    {
                        UBYTE *Q2=Q;

                        for(n=wo->xa;n<(wo->xe)+1;n++)
                        {

                            PutPixel(n,y,((*Q2)<<16)+((*(Q2+1))<<8)+*(Q2+2));
                            Q2+=3;
                        }
                    }
                    break;
                case 32:
                    {
                        ULONG *Q2=(ULONG *)Q;

                        for(n=wo->xa;n<(wo->xe)+1;n++)PutPixel(n,y,*Q2++);
                    }
                    break;

            }
        }
        pic+=gfx_bpl;Q+=VESA_SoftWidth;
    }
    M1;
}



// Ohne Clipping, macht nur Schwarz
void softbar( short xa, short ya, short xe, short ye )
{
    short y;
    int br=(xe-xa+1)*VESA_Bypp;
    UBYTE *M=VESA_SoftScreen+VESA_SoftWidth*ya+xa*VESA_Bypp,col=DarkestColor;

    if(VESA_TrueCol)col=0x0;

    for(y=ya;y<ye+1;y++)
    {
        memset(M,col,br);
        M+=VESA_SoftWidth;
    }
}








void video( void )
{
    BOOL r;

    switch(ScreenModeNum)
    {
        case 6: ScrX=1280-1;ScrY=1024-1;VESA_TrueCol=FALSE;
                r=SetVesa(_1280x1024c256);
                if(r)break;

        case 5: ScrX=1024-1;ScrY=768-1;VESA_TrueCol=FALSE;
                r=SetVesa(_1024x768c256);
                if(r)break;

        case 4: ScrX=800-1;ScrY=600-1;VESA_TrueCol=FALSE;
                r=SetVesa(_800x600c256);
                if(r)break;

                ScrX=640-1;ScrY=480-1;VESA_TrueCol=FALSE;
                r=SetVesa(_640x480c256);
                break;

        case 3: ScrX=640-1;ScrY=480-1;VESA_TrueCol=TRUE;
                r=SetVesa(_640x480c16m);
                if(r)break;

        case 2: ScrX=640-1;ScrY=480-1;VESA_TrueCol=TRUE;
                r=SetVesa(_640x480c32k);
                if(r)break;

        case 1: ScrX=640-1;ScrY=480-1;VESA_TrueCol=FALSE;
                r=SetVesa(_640x480c256);
                break;

        case 0: ScrX=320-1;ScrY=200-1;VESA_TrueCol=FALSE;
                r=SetVesa(_320x200c256);
                break;
    }

    
    VESA_Bypp=(VESA_Bpp+1)>>3;   // +1 wegen HiColor (15+1 Bit)
    if(!r){ printf("Konnte Grafikbildschirm nicht ffnen!\n");CloseAll();exit(0); }

    if(VESA_SoftScreen)free(VESA_SoftScreen);
    VESA_SoftWidth=(ScrX+1)*VESA_Bypp;
    VESA_SoftScreen=malloc((ScrY+1)*VESA_SoftWidth);

    DarkestColor=0;softbar(0,0,ScrX,ScrY);
    ScrClip.xa=0;ScrClip.ya=0;ScrClip.xe=ScrX;ScrClip.ye=ScrY;


    CopySoftScreen(&ScrClip);


    Sy_MouseInstall();
    Sy_MouseArea(0,0,ScrX-1,ScrY-1);

    M1;

/*    if(!VESA_TrueCol)
    {
        UBYTE far *RGB=RGBtab;
        int i;

        *RGB++=0;*RGB++=0;*RGB++=0;
        *RGB++=63;*RGB++=63;*RGB++=63;
        for(i=0;i<254*3;i++)*RGB++=0;
        SetRGBPaletteTab();
    }
*/
}


BOOL OpenAll( void )
{
    short selector;
    union REGS regs;
    FILE *datei;

    Pic[0].ptr=0;
    Pic[1].ptr=0;
    memset(&regs,0,sizeof(regs));       // Alloc Dos-Mem
    regs.w.ax=0x0100;
    regs.w.bx=16*3+1;
    int386(0x31,&regs,&regs);
    if(regs.x.cflag!=0)return(FALSE);
    DosSeg=regs.w.ax;
    selector=regs.w.dx;

    DosMem=MK_FP(selector,0);
    RGBtab=(void far *)DosMem;
    VESA_modeinfo=(void far *)DosMem;
    VESA_infoblock=(void far *)DosMem;

    // Font nachladen

    FontTab=malloc(8*223);
    if(FontTab==0)return(FALSE);
    if((datei=fopen("font.dat","rb"))==NULL)return(FALSE);
    fread(FontTab,223,8,datei);
    fclose(datei);
    return(TRUE);
}


void CloseAll( void )
{
    if(VESA_SoftScreen)free(VESA_SoftScreen);
    if(VESA_VideoOn)
    {
        union REGS regs;

        regs.w.ax=0x3;
        int386(0x10,&regs,&regs);    // Textmodus
    }
    if(FontTab)free(FontTab);
//    _dos_freemem((UWORD)(((ULONG)DosMem)>>4));

    if(Pic[0].ptr)free(Pic[0].ptr);
    if(Pic[1].ptr)free(Pic[1].ptr);

//  printf("CPUSpeed: %d %f\n",CPUSpeed,DitherStep);
    if(zap!=0)printf("(%ld)\n",zap);
}

void DErr( char *txt )      // Fehler DeadEnd
{
    CloseAll();printf(txt);exit(0);
}



BOOL readpcx( char *filename2, struct MemPic *MemPicZ )
{
    char *M,*fileptr=0,*Q;
    int r,g,b,z,handle;
    ULONG l,linesize;
    int FileSize=0;
    UBYTE i,e;
    FILE *pcxfile=0;
    int graumin=10000,graumax=0,redmax=0,graumid=10000,shadmid=10000;
    BOOL FileOk=TRUE,Coded=FALSE;
    char f2[80],filename[80];

    if(VESA_TrueCol)sprintf(filename,"BLD24\\%s",filename2);
        else sprintf(filename,"BLD8\\%s",filename2);
    strcpy(f2,filename);

    handle=open(f2,O_RDONLY);
    if(handle==-1)
    {
        z=strlen(filename);if(z<3)return(FALSE);
        f2[z-3]='B';f2[z-2]='L';f2[z-1]='D';
        Coded=TRUE;
        handle=open(f2,O_RDONLY);
        if(handle==-1)return(FALSE);
    }
    FileSize=filelength(handle)-sizeof(PCXHEADER);
    close(handle);
    if((pcxfile=fopen(filename,"rb"))==NULL)return(FALSE);

    if(fread(&pcxhdr,1,sizeof(PCXHEADER),pcxfile)<sizeof(PCXHEADER))FileOk=FALSE;
    if(Coded)
    {
        UBYTE *M2;

        M2=(UBYTE *)(&pcxhdr);
        for(i=0;i<25;i++)*M2++=(((*M2)&0xF)<<4)+(((*M2)&0xF0)>>4);
    }

    if(pcxhdr.bitsperpixel!=8)FileOk=FALSE;      // 8 oder 24Bit

    if(!FileOk)
    {
        fclose(pcxfile);
        return(FALSE);
    }

    linesize=(long)pcxhdr.bytesperline*(long)pcxhdr.nplanes*
        (long)(1+pcxhdr.ymax-pcxhdr.ymin);

    MemPicZ->b=pcxhdr.bytesperline;
    MemPicZ->h=(pcxhdr.ymax)-(pcxhdr.ymin)+1;

    if(MemPicZ->ptr!=0){ free(MemPicZ->ptr);MemPicZ->ptr=0; }

    MemPicZ->ptr=malloc(linesize);
    if(MemPicZ->ptr==0)return(FALSE);

    if(pcxhdr.encoding==1)   // Komprimiert
    {
        M=MemPicZ->ptr;
        fileptr=malloc(FileSize);
        if(fileptr==0){ fclose(pcxfile);return(FALSE); }

        fread(fileptr,FileSize,1,pcxfile);Q=fileptr;
        for(l=0;l<linesize;)
        {
            i=*Q++;
            if(i>192)
            {
                i=0x3f & i;
                e=*Q++;
                for(z=0;z<i;z++)*M++=e;
                l+=(ULONG)i;
            }
            else { *M++=i;l++; }
        }
        free(fileptr);
    }
    else fread(MemPicZ->ptr,linesize,1,pcxfile);

    if(pcxhdr.nplanes!=3)                 // 24Bit->keine Palette lesen
    {
        UBYTE far *Col=RGBtab;

        fseek(pcxfile,-256*3,SEEK_END);
        for(l=0;l<256;l++)
        {
            r=getc(pcxfile)>>2;
            g=getc(pcxfile)>>2;
            b=getc(pcxfile)>>2;
            *Col++=r;*Col++=g;*Col++=b;

            if((unsigned int)r+(unsigned int)g+(unsigned int)b<graumin){ DarkestColor=l;graumin=(unsigned int)r+(unsigned int)g+(unsigned int)b; }
            if((unsigned int)r+(unsigned int)g+(unsigned int)b>graumax){ LightestColor=l;graumax=(unsigned int)r+(unsigned int)g+(unsigned int)b; }
            if(2000+(unsigned int)r-(unsigned int)g-(unsigned int)b>redmax){ RedestColor=l;redmax=2000+(unsigned int)r-(unsigned int)g-(unsigned int)b; }
            if(abs((unsigned int)r-45)+abs((unsigned int)g-45)+abs((unsigned int)b-45)<graumid){ GreyestColor=l;graumid=abs((unsigned int)r-45)+abs((unsigned int)g-45)+abs((unsigned int)b-45); }
            if(abs((unsigned int)r-30)+abs((unsigned int)g-30)+abs((unsigned int)b-30)<shadmid){ ShadowColor=l;shadmid=abs((unsigned int)r-30)+abs((unsigned int)g-30)+abs((unsigned int)b-30); }
        }
    }

    fclose(pcxfile);
    return(TRUE);
}

/*
BOOL writepcx24( char *filename, HDC dc, int br, int ho )
{
    FILE *pcxfile=0;
    UBYTE *PCXPtr,*walker,*walker2,*walker3;

	PCXPtr=(UBYTE *)malloc(3*ho*br);

	if(!PCXPtr)return(FALSE);

 
	walker=PCXPtr;walker2=PCXPtr+br;walker3=PCXPtr+br*2;
	for(int y=0;y<ho;y++)
	{
		for(int x=0;x<br;x++)
		{
			ULONG p;
			
			p=GetPixel(dc,x,y);

			*walker3++=(UBYTE)((p>>16)&0xff);
			*walker2++=(UBYTE)((p>>8)&0xff);
			*walker++=(UBYTE)((p)&0xff);
		}
		walker+=br*2;
		walker2+=br*2;
		walker3+=br*2;
	}

    if((pcxfile=fopen(filename,"wb"))==NULL)return(FALSE);

	pcxhdr.manufacturer=0x0a;
	pcxhdr.version=5;
    pcxhdr.encoding=1;  // komprimiert
	pcxhdr.bitsperpixel=8;
    pcxhdr.xmin=0;pcxhdr.ymin=0;
    pcxhdr.xmax=br-1;pcxhdr.ymax=ho-1;
	pcxhdr.nplanes=3;
	pcxhdr.reserved=0;
    pcxhdr.bytesperline=br;
	pcxhdr.palettetype=0;
    pcxhdr.hres=72;
    pcxhdr.vres=72;
	pcxhdr.palettetype=1;

    if(fwrite(&pcxhdr,1,sizeof(PCXHEADER),pcxfile)<sizeof(PCXHEADER)){ fclose(pcxfile);return(FALSE); }

	walker=PCXPtr;
    for(y=0;y<ho;y++)
        for(int x=0;x<br*3;)
        {
            UBYTE Byte=*walker++,Count=1;

            x++;
            while(*walker==Byte && Count<63 && x<br*3)
            {
                Count++;walker++;x++;
            }
            if (Count>1 || Byte>=0xc0)
            {
                Count|=0xc0;
                putc(Count,pcxfile);
            }
            putc(Byte,pcxfile);
        }
}

*/

BOOL writepcx( char *filename2, struct MemPic *MemPicZ )
{
    ULONG l;
    int x,y;
    FILE *pcxfile=0;
    char filename[80];
    UBYTE *PCXPtr=MemPicZ->ptr;

    if(VESA_TrueCol)sprintf(filename,"BLD24\\%s",filename2);
        else sprintf(filename,"BLD8\\%s",filename2);

    if((pcxfile=fopen(filename,"wb"))==NULL)return(FALSE);


	memset(&pcxhdr,0,sizeof(PCXHEADER));

	pcxhdr.manufacturer=0x0a;
	pcxhdr.version=5;
	pcxhdr.bitsperpixel=8;
	pcxhdr.nplanes=1;
	pcxhdr.palettetype=0;



    pcxhdr.encoding=1;  // komprimiert

    pcxhdr.xmin=0;pcxhdr.ymin=0;
    pcxhdr.xmax=MemPicZ->b-1;pcxhdr.ymax=MemPicZ->h-1;
    pcxhdr.bytesperline=MemPicZ->b;
    pcxhdr.hres=MemPicZ->b;
    pcxhdr.vres=MemPicZ->h;
    
    if(fwrite(&pcxhdr,1,sizeof(PCXHEADER),pcxfile)<sizeof(PCXHEADER)){ fclose(pcxfile);return(FALSE); }

    for(y=0;y<MemPicZ->h;y++)
        for(x=0;x<MemPicZ->b;)
        {
            UBYTE Byte=*PCXPtr++,Count=1;

            x++;
            while(*PCXPtr==Byte && Count<63 && x<MemPicZ->b)
            {
                Count++;PCXPtr++;x++;
            }
            if (Count>1 || Byte>=0xc0)
            {
                Count|=0xc0;
                putc(Count,pcxfile);
            }
            putc(Byte,pcxfile);
        }



//    fwrite(MemPicZ->ptr,MemPicZ->b,MemPicZ->h,pcxfile);

    
    // Palette schreiben
    putc(0x0c,pcxfile);
    {
        UBYTE far *Col=RGBtab;

        for(l=0;l<256*3;l++)
        {
            putc((*Col++)<<2,pcxfile);
        }
    }

    fclose(pcxfile);
    return(TRUE);
}


// Zeiger auf 32Bit-Bitmap mit Bild
BOOL writepcx24( char *filename2, ULONG *orig, int br, int ho )
{
	char filename[256];
	int x,y;
	PCXHEADER pcxhdr;
    FILE *pcxfile=0;
    UBYTE *PCXPtr,*walker,*walker2,*walker3;

	PCXPtr=(UBYTE *)malloc(3*ho*br);

    if(VESA_TrueCol)sprintf(filename,"BLD24\\%s",filename2);
        else sprintf(filename,"BLD8\\%s",filename2);

	if(!PCXPtr)return(FALSE);
 
	walker=PCXPtr;walker2=PCXPtr+br;walker3=PCXPtr+br*2;
	for(y=0;y<ho;y++)
	{
		for(x=0;x<br;x++)
		{
			ULONG p;
			
			p=*orig++;

			*walker3++=(p>>16)&0xff;
			*walker2++=(p>>8)&0xff;
			*walker++=(p)&0xff;
		}
		walker+=br*2;
		walker2+=br*2;
		walker3+=br*2;
	}

	memset(&pcxhdr,0,sizeof(PCXHEADER));


//    if(VESA_TrueCol)
//		sprintf(filename,"BLD24\\%s",filename2);
//        else sprintf(filename,"BLD8\\%s",filename2);

    if((pcxfile=fopen(filename,"wb"))==NULL)return(FALSE);

	pcxhdr.manufacturer=0x0a;
	pcxhdr.version=5;
    pcxhdr.encoding=1;  // komprimiert
	pcxhdr.bitsperpixel=8;
    pcxhdr.xmin=0;pcxhdr.ymin=0;
    pcxhdr.xmax=br-1;pcxhdr.ymax=ho-1;
	pcxhdr.nplanes=3;
	pcxhdr.reserved=0;
    pcxhdr.bytesperline=br;
	pcxhdr.palettetype=0;
    pcxhdr.hres=72;
    pcxhdr.vres=72;
	pcxhdr.palettetype=1;

    if(fwrite(&pcxhdr,1,sizeof(PCXHEADER),pcxfile)<sizeof(PCXHEADER)){ fclose(pcxfile);return(FALSE); }

	walker=PCXPtr;
    for(y=0;y<ho;y++)
        for(x=0;x<br*3;)
        {
            UBYTE Byte=*walker++,Count=1;

            x++;
            while(*walker==Byte && Count<63 && x<br*3)
            {
                Count++;walker++;x++;
            }
            if (Count>1 || Byte>=0xc0)
            {
                Count|=0xc0;
                putc(Count,pcxfile);
            }
            putc(Byte,pcxfile);
        }

    fclose(pcxfile);

	free(PCXPtr);

    return(TRUE);
}






// Intern *******************************************************

short ColorComp( ULONG a, ULONG b )
{
    unsigned short r1,g1,b1,r2,g2,b2,gr1,gr2;

    r1=(a>>16) & 0xFF;
    g1=(a>>8) & 0xFF;
    b1=a & 0xFF;
    r2=(b>>16) & 0xFF;
    g2=(b>>8) & 0xFF;
    b2=b & 0xFF;

    gr1=r1+g1+b1;gr2=r2+g2+b2;

    return((abs(gr1-gr2)<<1)+abs(r1-r2)+abs(g1-g2)+abs(b1-b2));
}

// Mouse ********************************************************

void Sy_MouseInstall( void )
{
    union REGS regs;

    regs.w.ax=0;
    int386(0x33,&regs,&regs);
/*  regs.w.ax=15;
    regs.w.cx=1;
    regs.w.dx=1;
    int386(0x33,&regs,&regs);
*/
}

void Sy_MouseShow( short Nu )
{
    short i;
    ULONG *M=MouseBack;
    short ml=10;

    if(Nu)MouseState++; else MouseState--;

    if(MouseState==1)Nu=!0; else Nu=0;

    if(Nu && !MouseShow && MouseX!=-1)
    {
        for(i=MouseX-ml;i<MouseX+ml+1;i++){ *M++=GetPixel(i,MouseY);*M++=GetPixel(i,MouseY+1); }
        for(i=MouseY-ml;i<MouseY+ml+1;i++){ *M++=GetPixel(MouseX,i);*M++=GetPixel(MouseX+1,i); }

        for(i=MouseY-ml;i<MouseY+ml;i++)PutPixel(MouseX+1,i,DarkestColor);
        for(i=MouseX-ml;i<MouseX+ml;i++)PutPixel(i,MouseY+1,DarkestColor);
        for(i=MouseY-ml;i<MouseY+ml;i++)PutPixel(MouseX,i,LightestColor);
        for(i=MouseX-ml;i<MouseX+ml;i++)PutPixel(i,MouseY,LightestColor);
    }
    if(!Nu && MouseShow && MouseX!=-1)
    {
        for(i=MouseX-ml;i<MouseX+ml+1;i++)
        {
            PutPixel(i,MouseY,*M++);
            PutPixel(i,MouseY+1,*M++);
        }
        for(i=MouseY-ml;i<MouseY+ml+1;i++)
        {
            PutPixel(MouseX,i,*M++);
            PutPixel(MouseX+1,i,*M++);
        }
    }
    MouseShow=Nu;
}

void Sy_MouseGet( int *x, int *y, int *buttons )
{
    union REGS regs;

    regs.w.ax=3;
    int386(0x33,&regs,&regs);
    *x=regs.w.cx>>1;*y=regs.w.dx>>1;*buttons=regs.w.bx;
}

void Sy_MouseArea( short x1, short y1, short x2, short y2 )
{
    union REGS regs;

    regs.w.ax=7;
    regs.w.cx=x1<<1;
    regs.w.dx=x2<<1;
    int386(0x33,&regs,&regs);
    regs.w.ax=8;
    regs.w.cx=y1<<1;
    regs.w.dx=y2<<1;
    int386(0x33,&regs,&regs);
}


void Sy_MouseFree( void )
{
    Sy_MouseShow(FALSE);
}

// **********************



void SetRGBPaletteTAB( void )
{
    union REGS regs;
    struct SREGS sregs;

    if(VESA_TrueCol)return;

    memset(&sregs,0,sizeof(sregs));
    memset(&RMI,0,sizeof(RMI));                   // Set Mode
    RMI.EAX=0x00001012;
    RMI.ECX=256;
    RMI.EBX=0;
    RMI.EDX=0;
    RMI.ES=DosSeg;
    regs.w.ax=0x0300;
    regs.h.bl=0x10;
    regs.h.bh=0;
    regs.w.cx=0;
    sregs.es=FP_SEG(&RMI);
    regs.x.edi=FP_OFF(&RMI);
    int386x(0x31,&regs,&regs,&sregs);
}
















void InitGrid( int maxx, int maxy )
{
    float h,w,px,py,dx,dy,le;
    int i,e,x,y;
    int *PriListPtr=PriList;

    
    for(i=0;i<(XParts+1)*(YParts+1);i++)
    {
        p[i].b[0].state=0;
        px=1.0+(float)maxx*(float)(i%(XParts+1))/(float)XParts;
        py=1.0+(float)maxy*(float)(i/(XParts+1))/(float)YParts;

        w=0;
        for(e=0;e<Lin+1;e++)
        {
            if(e!=0)
            {
                dx=px-l[0][e].p.x;dy=py-l[0][e].p.y;
                h=sqrt(dx*dx+dy*dy);     // Ellipse Entf als Eingang
                dx-=l[0][e].v.x;dy-=l[0][e].v.y;
                h+=sqrt(dx*dx+dy*dy)-sqrt(l[0][e].v.x*l[0][e].v.x+l[0][e].v.y*l[0][e].v.y);
                if(h<MAXDIS)w+=1.0/(h*h+20.0)-1.0/(MAXDIS*MAXDIS+20.0); // Wichtung
            }
            else
            {
                w+=0.25/(px*px+0.00002)+
                   0.25/(py*py+0.00002)+
                   0.25/((maxx-px)*(maxx-px)+0.00002)+
                   0.25/((maxy-py)*(maxy-py)+0.00002)+0.0002;       
            }
        }

        for(e=0;e<Lin+1;e++)
        {
            if(e!=0)
            {
                dx=px-l[0][e].p.x;dy=py-l[0][e].p.y;
                le=l[0][e].v.x*l[0][e].v.x+l[0][e].v.y*l[0][e].v.y;

                p[i].b[e].x=(l[0][e].v.y*dy+l[0][e].v.x*dx)/le; // Skalarprod.
                p[i].b[e].y=(l[0][e].v.x*dy-l[0][e].v.y*dx)/le;

                h=sqrt(dx*dx+dy*dy);     // Ellipse Entf als Eingang
                dx-=l[0][e].v.x;dy-=l[0][e].v.y;
                h+=sqrt(dx*dx+dy*dy)-sqrt(l[0][e].v.x*l[0][e].v.x+l[0][e].v.y*l[0][e].v.y);
                if(h<MAXDIS)p[i].b[e].w=(1.0/(h*h+20.0)-1.0/(MAXDIS*MAXDIS+20.0))/w;
                    else p[i].b[e].w=0.0;
            }
            else
            {
                p[i].b[e].x=px;
                p[i].b[e].y=py;
                p[i].b[e].w=(0.25/(px*px+0.00002)+
                             0.25/(py*py+0.00002)+
                             0.25/((maxx-px)*(maxx-px)+0.00002)+
                             0.25/((maxy-py)*(maxy-py)+0.00002)+0.0002)/w;
            }
        }
    }
 
    for(y=0;y<YParts;y++)
        for(x=0;x<XParts;x++)*PriListPtr++=y*(XParts+1)+x;
}



void RecalcGrid( void )
{
    int i,e,State=AktState,x,y;
    float px,py;
    struct LinS lp[MAXLIN+1];

    if(SoftMode)State=MAXSTATES-1;

    for(e=0;e<Lin+1;e++)
    {

        lp[e].p.x=l[State][e].p.x;
        lp[e].p.y=l[State][e].p.y;
        lp[e].v.x=l[State][e].v.x;
        lp[e].v.y=l[State][e].v.y;
/*
        lp[e].p.x=2.0*l[0][e].p.x-l[AktState][e].p.x;
        lp[e].p.y=2.0*l[0][e].p.y-l[AktState][e].p.y;
        lp[e].v.x=-l[AktState][e].v.x;
        lp[e].v.y=-l[AktState][e].v.y;
*/
    }

/*
    for(i=0;i<(XParts+1)*(YParts+1);i++)
    {
        px=0;py=0;
        for(e=0;e<Lin+1;e++)
        {
            px+=p[i].b[e].w*(lp[e].p.x+p[i].b[e].x*lp[e].v.x-p[i].b[e].y*lp[e].v.y);
            py+=p[i].b[e].w*(lp[e].p.y+p[i].b[e].x*lp[e].v.y+p[i].b[e].y*lp[e].v.x);
        }
        p[i].newx=px*((float)(ScrX+1)/(float)Pic[0].b);p[i].newy=py*((float)(ScrY+1)/(float)Pic[0].h);
        p[i].newx-=0.5;
        p[i].newy-=0.5;
    }
*/

	i=0;
	for(y=0;y<=YParts;y++)
	for(x=0;x<=XParts;x++)
    {
		if(x==0 || x==XParts || y==0 || y==YParts)
		{
			px=(float)x/(float)XParts;py=(float)y/(float)YParts;

			p[i].newx=px*(float)(ScrX+1);p[i].newy=py*(float)(ScrY+1);
        }
		else
		{		
			px=0;py=0;
			for(e=0;e<Lin+1;e++)
			{
				px+=p[i].b[e].w*(lp[e].p.x+p[i].b[e].x*lp[e].v.x-p[i].b[e].y*lp[e].v.y);
				py+=p[i].b[e].w*(lp[e].p.y+p[i].b[e].x*lp[e].v.y+p[i].b[e].y*lp[e].v.x);
			}
        	p[i].newx=px*((float)(ScrX+1)/(float)Pic[0].b);p[i].newy=py*((float)(ScrY+1)/(float)Pic[0].h);
        }
		p[i].newx-=0.5;
        p[i].newy-=0.5;

		i++;
    }

}


void RenderGridInverse( struct MemPic *MyPic )     // Rendern der Inverse
{
    int x,y,part,z,XPSize=(ScrX+1)/XParts,intwy,breite=MyPic->b;
    float xxf,yyf,hxf,hyf,wy,iwy,invXPSize=1.0f/(float)XPSize;
	int dxx,dyy,xx,yy;
	unsigned int maxx=MyPic->b*65536,maxy=MyPic->h*65536;
    UBYTE *Ze,*Q=MyPic->ptr;

    for(y=0;y<ScrY+1;y++)
    {
        wy=(float)y*(YParts)/(ScrY+1);intwy=floor(wy);
        wy=(wy-intwy)*65536.0f;iwy=65536.0f-wy;
		Ze=&VESA_SoftScreen[y*(ScrX+1)];
        for(x=0;x<ScrX+1;)
        {
			part=(x/XPSize)+intwy*(XParts+1);
            xxf=p[part].newx*iwy + p[part+XParts+1].newx*wy+65536.0f/2.0f;
            yyf=p[part].newy*iwy + p[part+XParts+1].newy*wy+65536.0f/2.0f;
            hxf=p[part+1].newx*iwy + p[part+XParts+2].newx*wy+65536.0f/2.0f;
            hyf=p[part+1].newy*iwy + p[part+XParts+2].newy*wy+65536.0f/2.0f;

			xx=(int)xxf;yy=(int)yyf;

            dxx=(int)((hxf-xxf)*invXPSize);
            dyy=(int)((hyf-yyf)*invXPSize);

			z=x+XPSize;
			if(z>ScrX+1)z=ScrX+1;

           	if((unsigned int)xx>maxx || (unsigned int)yy>maxy
           	|| (unsigned int)(hxf)>maxx || (unsigned int)(hyf)>maxy)
			{
				for(;x<z;x++)
				{		    
					if((unsigned int)xx>maxx || (unsigned int)yy>maxy)*Ze++=0;
	            	else
    	        	{
        	    	    *Ze++=Q[(xx>>16)+breite*(yy>>16)];
            		}
					xx+=dxx;yy+=dyy;
				}
			}
			else
			{
				for(;x<z;x++)
				    *Ze++=Q[((xx+=dxx)>>16)+breite*((yy+=dyy)>>16)];
			}
        }
    }
    M0;CopySoftScreen(&ScrClip);M1;
}


void RenderGrid( struct MemPic *MyPic )    // normales Rendern mit Texturemapping
{
    int x,y,x2,y2,x2e,part=0,u,v,du,dv;
    float miny,maxy,xx,yy,
        XPSize=(float)(Pic[0].b)/(float)XParts,YPSize=(float)(Pic[0].h)/(float)YParts;
    int *PriListPtr=PriList;
    int br=MyPic->b;

    if(InverseGfx){ RenderGridInverse(&Pic[0]);return; }


    for(y=0;y<YParts;y++)
    for(x=0;x<XParts;x++)
    {
//      part=y*(XParts+1)+x;
        part=*PriListPtr++;

        xx=x*XPSize;yy=y*YPSize;
        WriteToLineTable(p[part].newx,p[part].newy,p[part+1].newx,p[part+1].newy,
                         xx,yy,xx+XPSize,yy);
        WriteToLineTable(p[part+1].newx,p[part+1].newy,p[part+XParts+2].newx,p[part+XParts+2].newy,
                         xx+XPSize,yy,xx+XPSize,yy+YPSize);
        WriteToLineTable(p[part+XParts+2].newx,p[part+XParts+2].newy,p[part+XParts+1].newx,p[part+XParts+1].newy,
                         xx+XPSize,yy+YPSize,xx,yy+YPSize);
        WriteToLineTable(p[part+XParts+1].newx,p[part+XParts+1].newy,p[part].newx,p[part].newy,
                         xx,yy+YPSize,xx,yy);

        miny=ScrY;maxy=0;
        if(p[part].newy<miny)miny=p[part].newy;
        if(p[part+1].newy<miny)miny=p[part+1].newy;
        if(p[part+XParts+1].newy<miny)miny=p[part+XParts+1].newy;
        if(p[part+XParts+2].newy<miny)miny=p[part+XParts+2].newy;

        if(p[part].newy>maxy)maxy=p[part].newy;
        if(p[part+1].newy>maxy)maxy=p[part+1].newy;
        if(p[part+XParts+1].newy>maxy)maxy=p[part+XParts+1].newy;
        if(p[part+XParts+2].newy>maxy)maxy=p[part+XParts+2].newy;

        for(y2=(int)miny;y2<=(int)maxy;y2++)
        {
            if(LineTable[y2][0].x<(float)ScrX)x2=(int)(LineTable[y2][0].x); else x2=ScrX;
            if(x2<0)x2=0;
            if(LineTable[y2][1].x<(float)ScrX)x2e=(int)(LineTable[y2][1].x); else x2e=ScrX;
            if(x2e<0)x2e=0;
            
            if(x2<x2e)
            {
                UBYTE *Ze=VESA_SoftScreen+(ScrX+1)*y2+x2,*Q=MyPic->ptr;
                
                u=(int)(LineTable[y2][0].u*65536.0);v=(int)(LineTable[y2][0].v*65536.0);
                du=(int)((LineTable[y2][1].u-LineTable[y2][0].u)*65536.0/(float)(x2e-x2));
                dv=(int)((LineTable[y2][1].v-LineTable[y2][0].v)*65536.0/(float)(x2e-x2));

                if(du>65536 || du<-65536 || dv>65536 || dv<-65536)
                {
                    for(;x2<x2e;x2++)
                    {
                        *Ze++=Q[(u>>16)+br*(v>>16)];
                        u+=du;v+=dv;
                    }
                }
                else
                {
                    {
                        UBYTE *Z=&Q[(v>>16)*br+(u>>16)];
                        
                        v&=0xffff;u&=0xffff;                                    
                        
                        if(du>0)
                        {
                            if(dv>0)
                            for(;x2<x2e;x2++)
                            {
                                *Ze++=*Z;u+=du;v+=dv;
                                if(u>65536){ u-=65536;Z++; }
                                if(v>65536){ v-=65536;Z+=br; }                                         
                            }
                            else
                            for(;x2<x2e;x2++)
                            {
                                *Ze++=*Z;u+=du;v+=dv;
                                if(u>65536){ u-=65536;Z++; }
                                if(v<0){ v+=65536;Z-=br; } 
                            }
                        }
                        else
                        {
                            if(dv>0)
                            for(;x2<x2e;x2++)
                            {
                                *Ze++=*Z;u+=du;v+=dv;
                                if(u<0){ u+=65536;Z--; }
                                if(v>65536){ v-=65536;Z+=br; } 
                            }
                            else
                            for(;x2<x2e;x2++)
                            {
                                *Ze++=*Z;u+=du;v+=dv;
                                if(u<0){ u+=65536;Z--; }
                                if(v<0){ v+=65536;Z-=br; } 
                            }
                        }
                    }
                }
			}

            if(x2>x2e)
            {
                UBYTE *Ze=VESA_SoftScreen+(ScrX+1)*y2+x2,*Q=MyPic->ptr;
                
                u=(int)(LineTable[y2][0].u*65536.0);v=(int)(LineTable[y2][0].v*65536.0);
                du=(int)(-(LineTable[y2][1].u-LineTable[y2][0].u)*65536.0/(float)(x2e-x2));
                dv=(int)(-(LineTable[y2][1].v-LineTable[y2][0].v)*65536.0/(float)(x2e-x2));
                
                if(du>65536 || du<-65536 || dv>65536 || dv<-65536)
                {
                    for(;x2>x2e;x2--)
                    {
                        *Ze--=Q[(u>>16)+br*(v>>16)];
                        u+=du;v+=dv;
                    }
                }
                else
                {
                    {
                        UBYTE *Z=&Q[(v>>16)*br+(u>>16)];
                        
                        v&=0xffff;u&=0xffff;                                    
                        
                        if(du>0)
                        {
                            if(dv>0)
                            for(;x2>x2e;x2--)
                            {
                                *Ze--=*Z;u+=du;v+=dv;
                                if(u>65536){ u-=65536;Z++; }
                                if(v>65536){ v-=65536;Z+=br; }                                         
                            }
                            else
                            for(;x2>x2e;x2--)
                            {
                                *Ze--=*Z;u+=du;v+=dv;
                                if(u>65536){ u-=65536;Z++; }
                                if(v<0){ v+=65536;Z-=br; } 
                            }
                        }
                        else
                        {
                            if(dv>0)
                            for(;x2>x2e;x2--)
                            {
                                *Ze--=*Z;u+=du;v+=dv;
                                if(u<0){ u+=65536;Z--; }
                                if(v>65536){ v-=65536;Z+=br; } 
                            }
                            else
                            for(;x2>x2e;x2--)
                            {
                                *Ze--=*Z;u+=du;v+=dv;
                                if(u<0){ u+=65536;Z--; }
                                if(v<0){ v+=65536;Z-=br; } 
                            }
                        }
                    }
                }   



                
            }
        }
    }
    M0;CopySoftScreen(&ScrClip);M1;
}




// a(xy): FARBEN
ULONG BilinearFilter( ULONG a00, ULONG a01, ULONG a10, ULONG a11, ULONG u, ULONG v )
{
	ULONG c;
	ULONG r0,r1;

	u&=0xffff;v&=0xffff;
	
	
	r0=(  ((a01>>0) & 0xff)*u + ((a00>>0) & 0xff)*(u^0xffff)  )>>16;
	r1=(  ((a11>>0) & 0xff)*u + ((a10>>0) & 0xff)*(u^0xffff)  )>>16;

	c=(  r1*v + r0*(v^0xffff)  )&0xff0000;

	r0=(  ((a01>>8) & 0xff)*u + ((a00>>8) & 0xff)*(u^0xffff)  )>>16;
	r1=(  ((a11>>8) & 0xff)*u + ((a10>>8) & 0xff)*(u^0xffff)  )>>16;

	c+=((  r1*v + r0*(v^0xffff)  )>>16)<<8;

	r0=(  (a01>>16)*u + (a00>>16)*(u^0xffff)  )>>16;
	r1=(  (a11>>16)*u + (a10>>16)*(u^0xffff)  )>>16;

	c+=(  r1*v + r0*(v^0xffff)  )>>16;

	return(c);	
}


void RenderGrid32( struct MemPic *MyPic )    // Rendern mit Texturemapping 32Bit
{
	ULONG *Dest=malloc((ScrX+1)*(ScrY+1)*4);

    int x,y,x2,y2,x2e,part=0,u,v,du,dv;
    float miny,maxy,xx,yy,
        XPSize=(float)(Pic[0].b)/(float)XParts,YPSize=(float)(Pic[0].h)/(float)YParts;
    int *PriListPtr=PriList;
    int br=MyPic->b;

	memset(Dest,0,(ScrX+1)*(ScrY+1)*4);

	if(!Dest)return;

    for(y=0;y<YParts;y++)
    for(x=0;x<XParts;x++)
    {
//      part=y*(XParts+1)+x;
        part=*PriListPtr++;

        xx=x*XPSize;yy=y*YPSize;
        WriteToLineTable(p[part].newx,p[part].newy,p[part+1].newx,p[part+1].newy,
                         xx,yy,xx+XPSize,yy);
        WriteToLineTable(p[part+1].newx,p[part+1].newy,p[part+XParts+2].newx,p[part+XParts+2].newy,
                         xx+XPSize,yy,xx+XPSize,yy+YPSize);
        WriteToLineTable(p[part+XParts+2].newx,p[part+XParts+2].newy,p[part+XParts+1].newx,p[part+XParts+1].newy,
                         xx+XPSize,yy+YPSize,xx,yy+YPSize);
        WriteToLineTable(p[part+XParts+1].newx,p[part+XParts+1].newy,p[part].newx,p[part].newy,
                         xx,yy+YPSize,xx,yy);

        miny=ScrY;maxy=0;
        if(p[part].newy<miny)miny=p[part].newy;
        if(p[part+1].newy<miny)miny=p[part+1].newy;
        if(p[part+XParts+1].newy<miny)miny=p[part+XParts+1].newy;
        if(p[part+XParts+2].newy<miny)miny=p[part+XParts+2].newy;

        if(p[part].newy>maxy)maxy=p[part].newy;
        if(p[part+1].newy>maxy)maxy=p[part+1].newy;
        if(p[part+XParts+1].newy>maxy)maxy=p[part+XParts+1].newy;
        if(p[part+XParts+2].newy>maxy)maxy=p[part+XParts+2].newy;

        for(y2=(int)miny;y2<=(int)maxy;y2++)
        {
            if(LineTable[y2][0].x<(float)ScrX)x2=(int)(LineTable[y2][0].x); else x2=ScrX;
            if(x2<0)x2=0;
            if(LineTable[y2][1].x<(float)ScrX)x2e=(int)(LineTable[y2][1].x); else x2e=ScrX;
            if(x2e<0)x2e=0;
            
            if(x2<x2e)
            {
                ULONG *Ze=Dest+(ScrX+1)*y2+x2,*Q=(ULONG *)MyPic->ptr;
                
                u=(int)(LineTable[y2][0].u*65536.0);v=(int)(LineTable[y2][0].v*65536.0);
                du=(int)((LineTable[y2][1].u-LineTable[y2][0].u)*65536.0/(float)(x2e-x2));
                dv=(int)((LineTable[y2][1].v-LineTable[y2][0].v)*65536.0/(float)(x2e-x2));

				for(;x2<x2e;x2++)
				{
					ULONG *Q2=&Q[(u>>16)+br*(v>>16)];
					*Ze++=BilinearFilter(Q2[0],Q2[1],Q2[br],Q2[1+br],u,v);
					u+=du;v+=dv;
				}
            }

            if(x2>x2e)
            {
                ULONG *Ze=Dest+(ScrX+1)*y2+x2,*Q=(ULONG *)MyPic->ptr;
                
                u=(int)(LineTable[y2][0].u*65536.0);v=(int)(LineTable[y2][0].v*65536.0);
                du=(int)(-(LineTable[y2][1].u-LineTable[y2][0].u)*65536.0/(float)(x2e-x2));
                dv=(int)(-(LineTable[y2][1].v-LineTable[y2][0].v)*65536.0/(float)(x2e-x2));
                
				for(;x2>x2e;x2--)
				{
					ULONG *Q2=&Q[(u>>16)+br*(v>>16)];
					*Ze--=BilinearFilter(Q2[0],Q2[1],Q2[br],Q2[1+br],u,v);	

					u+=du;v+=dv;
				}
            }
        }
    }
    M0;CopySoftScreen(&ScrClip);M1;

	writepcx24("save.pcx",Dest,ScrX+1,ScrY+1);

	free(Dest);
}



void WriteToLineTable( float xa, float ya, float xe, float ye, float ua, float va,float ue, float ve )
{
    int y;
    float dx,du,dv;

    if(ya<ye)
    {
        dx=(xe-xa)/(ye-ya+1);
        du=(ue-ua)/(ye-ya+1);
        dv=(ve-va)/(ye-ya+1);
        xa+=(dx/2.0);ua+=(du/2.0);va+=(dv/2.0);
        for(y=(int)ya;y<=(int)ye;y++)
        {
            if(y>=0 && y<=ScrY)
            {
                LineTable[y][0].x=xa;LineTable[y][0].u=ua;LineTable[y][0].v=va; 
            }
            xa+=dx;ua+=du;va+=dv;
        }
    }
    if(ye<ya)
    {
        dx=(xa-xe)/(ya-ye+1);
        du=(ua-ue)/(ya-ye+1);
        dv=(va-ve)/(ya-ye+1);
        xe+=(dx/2.0);ue+=(du/2.0);ve+=(dv/2.0);
        for(y=(int)ye;y<=(int)ya;y++)
        {
            if(y>=0 && y<=ScrY)
            {
                LineTable[y][1].x=xe;LineTable[y][1].u=ue;LineTable[y][1].v=ve; 
            }
            xe+=dx;ue+=du;ve+=dv;
        }
    }
}


void ShowLines( void )
{
    float di,x,y,dx,dy;
    int e,i,f=rand(),intdi;
	char str[80];

    if(DoShowLines==0)return;

    M0;
    for(e=1;e<Lin+1;e++)
    {
        di=sqrt(l[AktState][e].v.x*l[AktState][e].v.x+l[AktState][e].v.y*l[AktState][e].v.y)*0.25;
        x=l[AktState][e].p.x/(float)(Pic[0].b)*(ScrX+1.0);
        y=l[AktState][e].p.y/(float)(Pic[0].h)*(ScrY+1.0);
        dx=l[AktState][e].v.x/(float)(Pic[0].b)*(ScrX+1.0);
        dy=l[AktState][e].v.y/(float)(Pic[0].h)*(ScrY+1.0);
        intdi=(int)di;

        PutPixel((int)x+1,(int)y,f);
        PutPixel((int)x-1,(int)y,f);
        PutPixel((int)x,(int)y+1,f);
        PutPixel((int)x,(int)y-1,f);
        PutPixel((int)x,(int)y,f);

        PutPixel((int)(x+dx)+1,(int)(y+dy),f);
        PutPixel((int)(x+dx)-1,(int)(y+dy),f);
        PutPixel((int)(x+dx),(int)(y+dy)+1,f);
        PutPixel((int)(x+dx),(int)(y+dy)-1,f);
        PutPixel((int)(x+dx),(int)(y+dy),f);

        dx=dx/di;dy=dy/di;
        x+=dx*0.5;y+=dy*0.5;
        for(i=0;i<intdi;i++)
        {
            PutPixel((int)x,(int)y,f);
            x+=dx;
            y+=dy;
        }
    }

	outtextxy(3,3, "Ende:ESC   Punktzahl:+-   Feiner:F   Gleiten:G   Speichern:S   Anzeige:RETURN");
	outtextxy(3,13,"Mode:0..9  Inverse:I  Copy:C");


	sprintf(str,"%s %c",(AktState==0)?"Quelle":"Ziel",(AktState==0)?' ':(AktState+'0'));
	outtextxy(3,33,str);
	
    M1;
}




int main( int argc, char *argv[] )
{
    BOOL ShowHelp=FALSE,Ok;
    int c,MX,MY,b,i,e,Timer=1;
    char filename[80]={"frw.pcx"};

    for(i=1;i<argc;i++)
    {
        Ok=FALSE;
        if(stricmp(argv[i],"?")==0){ ShowHelp=TRUE;Ok=TRUE; }
        if(stricmp(argv[i],"/?")==0){ ShowHelp=TRUE;Ok=TRUE; }
        if(stricmp(argv[i],"HELP")==0){ ShowHelp=TRUE;Ok=TRUE; }
        if(stricmp(argv[i],"MD0")==0){ ScreenModeNum=0;Ok=TRUE; }
        if(stricmp(argv[i],"MD1")==0){ ScreenModeNum=1;Ok=TRUE; }
        if(stricmp(argv[i],"MD2")==0){ ScreenModeNum=2;Ok=TRUE; }
        if(stricmp(argv[i],"MD3")==0){ ScreenModeNum=3;Ok=TRUE; }
        if(stricmp(argv[i],"MD4")==0){ ScreenModeNum=4;Ok=TRUE; }
        if(stricmp(argv[i],"MD5")==0){ ScreenModeNum=5;Ok=TRUE; }
        if(stricmp(argv[i],"MD6")==0){ ScreenModeNum=6;Ok=TRUE; }
        if((argv[i][0]=='O' || argv[i][0]=='o') && argv[i][1]==':'){ strcpy(filename,&argv[i][2]);Ok=TRUE; }
 
        if(!Ok){ printf("Unbekannter Parameter : [%s]\n",argv[i]);ShowHelp=TRUE; }
    }

    if(ShowHelp)
    {
        printf("\nMorph [O:Bildname.pcx] [Bildschirmmodusnummer] (V0.8)\n");
        printf("                      programmiert von Mittring Martin\n\n");

        printf("Bildname: z.B. frw.pcx (mu im bld8 Verzeichnis sein)\n\n");

        printf("Bildschirmmodusnummer:\n");
        printf(" MD0 .. 320x200   256   Farben (VGA oder MCGA)\n");
        printf(" MD1 .. 640x480   256   Farben (VESA Treiber erforderlich!)\n");
        printf(" MD2 .. 640x480   32K   Farben (VESA Treiber erforderlich!)\n");
        printf(" MD3 .. 640x480   16.7M Farben (VESA Treiber erforderlich!)\n");
        printf(" MD4 .. 800x600   256   Farben (VESA Treiber erforderlich!)\n");
        printf(" MD5 .. 1024x768  256   Farben (VESA Treiber erforderlich!)\n");
        printf(" MD6 .. 1280x1024 256   Farben (VESA Treiber erforderlich!)\n\n");
        return(0);
    }

// Init

    if(!OpenAll())
    {
        CloseAll();
        printf("Fehler! Konnte Morph nicht initialisieren\n");
        return(-1);
    }


    video();

    if(!readpcx(filename,&Pic[0]))
    {
        CloseAll();
        printf("Konnte Bild nicht laden\n\n");
        return(-1);
    }
	
    PicXA=0,PicYA=0,PicXE=Pic[0].b,PicYE=Pic[0].h;
    SetRGBPaletteTAB();

	VESA_TrueCol=TRUE;
	{
		struct MemPic temp;
		
		if(readpcx(filename,&temp))
		{
			int x,y;
			ULONG *ptr=malloc(temp.b*temp.h*4);
			UBYTE *walker=temp.ptr,*walker2=temp.ptr+temp.b,*walker3=temp.ptr+temp.b*2;
			
			Pic[1].ptr=(UBYTE *)ptr;
			Pic[1].b=temp.b;
			Pic[1].h=temp.h;

			for(y=0;y<temp.h;y++)
			{
				for(x=0;x<temp.b;x++)
				{
					*ptr++=((*walker++)<<16)+((*walker2++)<<8)+((*walker3++));
				}
				walker+=temp.b*2;
				walker2+=temp.b*2;
				walker3+=temp.b*2;
			}
			
			free(temp.ptr);
		}
	}
	VESA_TrueCol=FALSE;


    // Morph init

    l[0][0].p.x=0;
    l[0][0].p.y=0;
    l[0][0].v.x=1;
    l[0][0].v.y=0;

    for(i=1;i<MAXLIN;i++)
    {
        l[0][i].p.x=10.0+i*30.0;
        l[0][i].p.y=10.0;
        l[0][i].v.x=0.0;
        l[0][i].v.y=60.0;
    }

    for(i=0;i<MAXSTATES;i++)
	{
		UsedState[i]=FALSE;
        for(e=0;e<Lin+1;e++)l[i][e]=l[0][e];
	}
	
    InitGrid(Pic[0].b-1,Pic[0].h-1);
    RecalcGrid();
    RenderGrid(&Pic[0]);
    ShowLines();


    while(RunPrg)
    {
        if(AktState==0)
		{
		//	CopySoftScreen(&ScrClip);
		}
		else
		{
			RecalcGrid();
			RenderGrid(&Pic[0]);
			ShowLines();
		}
		
        Sy_MouseGet(&MX,&MY,&b);


        if(b!=0)
        {
            int i=AktLin;

            if(i==0)
            {
                int e;
                float x=((float)MX*(float)(Pic[0].b)/(ScrX+1)),
                      y=((float)MY*(float)(Pic[0].h)/(ScrY+1)),h,wert=60.0;

                for(e=1;e<Lin+1;e++)
                {
                    h=(l[AktState][e].p.x-x)*(l[AktState][e].p.x-x)+(l[AktState][e].p.y-y)*(l[AktState][e].p.y-y);
                    if(h<wert){ wert=h;i=e; }
                    h=(l[AktState][e].p.x+l[AktState][e].v.x-x)*(l[AktState][e].p.x+l[AktState][e].v.x-x)
                      +(l[AktState][e].p.y+l[AktState][e].v.y-y)*(l[AktState][e].p.y+l[AktState][e].v.y-y);
                    if(h<wert){ wert=h;i=-e; }
                }

                if(wert==60.0)
				{
					i=0;

					if(AktState==0)
            		if(Lin!=MAXLIN-1)
					{
						Lin++;

		                l[AktState][Lin].p.x=x;
		                l[AktState][Lin].p.y=y;

						i=-Lin;
					}
                }
				else AktLin=i;
            }

            if(i>0)
            {
                l[AktState][i].v.x+=l[AktState][i].p.x;
                l[AktState][i].v.y+=l[AktState][i].p.y;
                l[AktState][i].p.x=((float)MX*(float)(Pic[0].b)/(ScrX+1));
                l[AktState][i].p.y=((float)MY*(float)(Pic[0].h)/(ScrY+1));
                l[AktState][i].v.x-=l[AktState][i].p.x;
                l[AktState][i].v.y-=l[AktState][i].p.y;
            }
            if(i<0)
            {
                l[AktState][-i].v.x=((float)MX*(float)(Pic[0].b)/(ScrX+1))-l[AktState][-i].p.x;
                l[AktState][-i].v.y=((float)MY*(float)(Pic[0].h)/(ScrY+1))-l[AktState][-i].p.y;
            }

			if(MX!=MouseX || MY!=MouseY)
			{
				if(AktState==0)
				{
					MouseX=MX;MouseY=MY;
					CopySoftScreen(&ScrClip);
            		ShowLines();delay(2);
				}
				else
				{
					M0;MouseX=MX;MouseY=MY;M1;
				}
			}
        }
        else
        {
			if(MX!=MouseX || MY!=MouseY)
			{
				M0;MouseX=MX;MouseY=MY;M1;
			}
			
            AktLin=0;
            if(Timer==0)ShowLines();
            delay(2);Timer++;if(Timer>10)Timer=0;
        }


        if(SoftMode)
        {
            for(e=0;e<Lin+1;e++)
            {
                l[MAXSTATES-1][e].p.x=(l[MAXSTATES-1][e].p.x)*0.6+(l[AktState][e].p.x)*0.4;
                l[MAXSTATES-1][e].p.y=(l[MAXSTATES-1][e].p.y)*0.6+(l[AktState][e].p.y)*0.4;
                l[MAXSTATES-1][e].v.x=(l[MAXSTATES-1][e].v.x)*0.6+(l[AktState][e].v.x)*0.4;
                l[MAXSTATES-1][e].v.y=(l[MAXSTATES-1][e].v.y)*0.6+(l[AktState][e].v.y)*0.4;
            }
        }

        if(kbhit())
        {
            c=getch();if(!c)c=-getch();

            if(c==27)
            {
                RunPrg=FALSE;
            }
            if(c>='0' && c<='9')
            {
				AktState=c-'0';

				if(!UsedState[AktState])
				{
//					outtextxy(ScrX/2-30,ScrY/2-4,"");
	                for(e=0;e<MAXLIN;e++)l[AktState][e]=l[0][e];

					UsedState[AktState]=TRUE;
				}
				if(!SoftMode)
				{
					InitGrid(Pic[0].b-1,Pic[0].h-1);
            	    RecalcGrid();
    				RenderGrid(&Pic[0]);
				}
            }
            if(c=='c' || c=='C')
            {
                for(e=0;e<MAXLIN;e++)l[AktState][e]=l[0][e];
            }
            if(c=='g' || c=='G')
            {
                SoftMode=!SoftMode;
                if(SoftMode)
                {
                    for(e=0;e<Lin+1;e++)l[MAXSTATES-1][e]=l[AktState][e];
                }
            }
            if(c=='s' || c=='S')
            {
                struct MemPic pics;

                pics.b=ScrX+1;pics.h=ScrY+1;pics.ptr=VESA_SoftScreen;

				outtextxy(ScrX/2-5*8,ScrY/2,"Saving ...");
				writepcx("save.pcx",&pics);
				RecalcGrid();
				VESA_TrueCol=TRUE;
                if(Pic[1].ptr!=0)RenderGrid32(&Pic[1]);
				VESA_TrueCol=FALSE;
            }
            if(c=='+' && Lin!=MAXLIN-1)
			{
				Lin++;InitGrid(Pic[0].b-1,Pic[0].h-1);
				RecalcGrid();
    			RenderGrid(&Pic[0]);
			}
            if(c=='-' && Lin>0)
			{
				Lin--;InitGrid(Pic[0].b-1,Pic[0].h-1);
                RecalcGrid();
    			RenderGrid(&Pic[0]);
			}
            if(c==13)
			{
				DoShowLines=!DoShowLines;
				CopySoftScreen(&ScrClip);
			}
            if(c=='f' || c=='F')
            {
                FineGfx=!FineGfx;
                if(FineGfx){ XParts=64;YParts=48; }
                    else { XParts=32;YParts=24; }
                InitGrid(Pic[0].b-1,Pic[0].h-1);
            }
            if(c=='i')
            {
                InverseGfx=!InverseGfx;
            }
        }
    }
    CloseAll();
//  printf("%d\n",ExitCode);
    return(ExitCode);
}
